 ///////////////////////////////////////////////////////////////////////////////
 // (c) Copyright 2010 Xilinx, Inc. All rights reserved.
 //
 // This file contains confidential and proprietary information
 // of Xilinx, Inc. and is protected under U.S. and
 // international copyright and other intellectual property
 // laws.
 //
 // DISCLAIMER
 // This disclaimer is not a license and does not grant any
 // rights to the materials distributed herewith. Except as
 // otherwise provided in a valid license issued to you by
 // Xilinx, and to the maximum extent permitted by applicable
 // law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
 // WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
 // AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
 // BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
 // INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
 // (2) Xilinx shall not be liable (whether in contract or tort,
 // including negligence, or under any other theory of
 // liability) for any loss or damage of any kind or nature
 // related to, arising under or in connection with these
 // materials, including for any direct, or any indirect,
 // special, incidental, or consequential loss or damage
 // (including loss of data, profits, goodwill, or any type of
 // loss or damage suffered as a result of any action brought
 // by a third party) even if such damage or loss was
 // reasonably foreseeable or Xilinx had been advised of the
 // possibility of the same.
 //
 // CRITICAL APPLICATIONS
 // Xilinx products are not designed or intended to be fail-
 // safe, or for use in any application requiring fail-safe
 // performance, such as life-support or safety devices or
 // systems, Class III medical devices, nuclear facilities,
 // applications related to the deployment of airbags, or any
 // other applications that could lead to death, personal
 // injury, or severe property or environmental damage
 // (individually and collectively, "Critical
 // Applications"). Customer assumes the sole risk and
 // liability of any use of Xilinx products in Critical
 // Applications, subject only to applicable laws and
 // regulations governing limitations on product liability.
 //
 // THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
 // PART OF THIS FILE AT ALL TIMES.
 // 
 // 
 ///////////////////////////////////////////////////////////////////////////////
 //
 //  AXI_TO_DRP
 //
 //
 //  Description: This light wrapper/shim convertes AXI4 Lite interface
 //               signals to DRP signals
 //
 //
 ///////////////////////////////////////////////////////////////////////////////
 
 `timescale 1 ns/1 ps

   (* core_generation_info = "g1_ipcat_aur,aurora_64b66b_v9_1,{c_aurora_lanes=4,c_column_used=right,c_gt_clock_1=GTXQ1,c_gt_clock_2=None,c_gt_loc_1=X,c_gt_loc_10=X,c_gt_loc_11=X,c_gt_loc_12=X,c_gt_loc_13=X,c_gt_loc_14=X,c_gt_loc_15=X,c_gt_loc_16=X,c_gt_loc_17=X,c_gt_loc_18=X,c_gt_loc_19=X,c_gt_loc_2=X,c_gt_loc_20=X,c_gt_loc_21=X,c_gt_loc_22=X,c_gt_loc_23=X,c_gt_loc_24=X,c_gt_loc_25=X,c_gt_loc_26=X,c_gt_loc_27=X,c_gt_loc_28=X,c_gt_loc_29=X,c_gt_loc_3=X,c_gt_loc_30=X,c_gt_loc_31=X,c_gt_loc_32=X,c_gt_loc_33=X,c_gt_loc_34=X,c_gt_loc_35=X,c_gt_loc_36=X,c_gt_loc_37=X,c_gt_loc_38=X,c_gt_loc_39=X,c_gt_loc_4=X,c_gt_loc_40=X,c_gt_loc_41=X,c_gt_loc_42=X,c_gt_loc_43=X,c_gt_loc_44=X,c_gt_loc_45=X,c_gt_loc_46=X,c_gt_loc_47=X,c_gt_loc_48=X,c_gt_loc_5=1,c_gt_loc_6=2,c_gt_loc_7=3,c_gt_loc_8=4,c_gt_loc_9=X,c_lane_width=4,c_line_rate=10.0,c_gt_type=gtx,c_qpll=true,c_nfc=true,c_nfc_mode=COMP,c_refclk_frequency=125.0,c_simplex=false,c_simplex_mode=TX,c_stream=false,c_ufc=false,c_user_k=false,flow_mode=Completion_NFC,interface_mode=Framing,dataflow_config=Duplex}" *) 
(* DowngradeIPIdentifiedWarnings="yes" *)
 module g1_ipcat_aur_AXI_TO_DRP #
 (
     parameter            DATA_WIDTH         = 16 // DATA bus width
 )
 `define DLY #1
 (
 
     //-------------------- AXI4-Lite Interface -------------------------------
 
 
     //-------------------- Write Address Channel --------------------------
     input     [31:0]       S_AXI_AWADDR,
       input                 S_AXI_AWVALID, 
       output                S_AXI_AWREADY, 
       input                 S_AXI_AWVALID_LANE1, 
       output                S_AXI_AWREADY_LANE1, 
       input                 S_AXI_AWVALID_LANE2, 
       output                S_AXI_AWREADY_LANE2, 
       input                 S_AXI_AWVALID_LANE3, 
       output                S_AXI_AWREADY_LANE3, 
     //-------------------- Write Data Channel -----------------------------
     input     [31:0]      S_AXI_WDATA,
       input                 S_AXI_WVALID, 
       output                S_AXI_WREADY, 
       output                S_AXI_BVALID, 
       input                 S_AXI_WVALID_LANE1, 
       output                S_AXI_WREADY_LANE1, 
       output                S_AXI_BVALID_LANE1, 
       input                 S_AXI_WVALID_LANE2, 
       output                S_AXI_WREADY_LANE2, 
       output                S_AXI_BVALID_LANE2, 
       input                 S_AXI_WVALID_LANE3, 
       output                S_AXI_WREADY_LANE3, 
       output                S_AXI_BVALID_LANE3, 
     //-------------------- Read Address Channel ---------------------------
     input      [31:0]      S_AXI_ARADDR,
       input                 S_AXI_ARVALID, 
       output                S_AXI_ARREADY, 
       input                 S_AXI_ARVALID_LANE1, 
       output                S_AXI_ARREADY_LANE1, 
       input                 S_AXI_ARVALID_LANE2, 
       output                S_AXI_ARREADY_LANE2, 
       input                 S_AXI_ARVALID_LANE3, 
       output                S_AXI_ARREADY_LANE3, 
     //-------------------- Read Data Channel -----------------------------
     output      [31:0]     S_AXI_RDATA,
       output                 S_AXI_RVALID, 
       input                  S_AXI_RREADY, 
       output                 S_AXI_RVALID_LANE1, 
       input                  S_AXI_RREADY_LANE1, 
       output                 S_AXI_RVALID_LANE2, 
       input                  S_AXI_RREADY_LANE2, 
       output                 S_AXI_RVALID_LANE3, 
       input                  S_AXI_RREADY_LANE3, 
 
    //---------------------- GT DRP Ports ----------------------
     output   [8:0]   DRPADDR_IN,
     output   [15:0]  DRPDI_IN,
       input  [15:0]    DRPDO_OUT, 
       input            DRPRDY_OUT, 
       output           DRPEN_IN, 
       output           DRPWE_IN, 
       input  [15:0]    DRPDO_OUT_LANE1, 
       input            DRPRDY_OUT_LANE1, 
       output           DRPEN_IN_LANE1, 
       output           DRPWE_IN_LANE1, 
       input  [15:0]    DRPDO_OUT_LANE2, 
       input            DRPRDY_OUT_LANE2, 
       output           DRPEN_IN_LANE2, 
       output           DRPWE_IN_LANE2, 
       input  [15:0]    DRPDO_OUT_LANE3, 
       input            DRPRDY_OUT_LANE3, 
       output           DRPEN_IN_LANE3, 
       output           DRPWE_IN_LANE3, 
 
     // System Interface
     input                 DRP_CLK_IN
 
 );
 
 //***********************************Wire Declarations***************************
       wire    wr_addr_en_i; 
       wire    rd_addr_en_i; 
       wire    wr_data_en_i; 
       wire    rd_data_en_i; 
       wire    wr_addr_en_lane1_i; 
       wire    rd_addr_en_lane1_i; 
       wire    wr_data_en_lane1_i; 
       wire    rd_data_en_lane1_i; 
       wire    wr_addr_en_lane2_i; 
       wire    rd_addr_en_lane2_i; 
       wire    wr_data_en_lane2_i; 
       wire    rd_data_en_lane2_i; 
       wire    wr_addr_en_lane3_i; 
       wire    rd_addr_en_lane3_i; 
       wire    wr_data_en_lane3_i; 
       wire    rd_data_en_lane3_i; 
 
 //*********************************Main Body of Code**********************************
 
 // Tie all READY signals high to be laways enabled
 
     assign S_AXI_AWREADY = 1'b1; 
     assign S_AXI_ARREADY = 1'b1; 
     assign S_AXI_WREADY = 1'b1; 
     assign S_AXI_RVALID = 1'b1; 
     assign S_AXI_AWREADY_LANE1 = 1'b1; 
     assign S_AXI_ARREADY_LANE1 = 1'b1; 
     assign S_AXI_WREADY_LANE1 = 1'b1; 
     assign S_AXI_RVALID_LANE1 = 1'b1; 
     assign S_AXI_AWREADY_LANE2 = 1'b1; 
     assign S_AXI_ARREADY_LANE2 = 1'b1; 
     assign S_AXI_WREADY_LANE2 = 1'b1; 
     assign S_AXI_RVALID_LANE2 = 1'b1; 
     assign S_AXI_AWREADY_LANE3 = 1'b1; 
     assign S_AXI_ARREADY_LANE3 = 1'b1; 
     assign S_AXI_WREADY_LANE3 = 1'b1; 
     assign S_AXI_RVALID_LANE3 = 1'b1; 
 
 // Generate enables for write & read DRP operations
 
     assign wr_addr_en = S_AXI_AWVALID && S_AXI_AWREADY; 
     assign rd_addr_en = S_AXI_ARVALID && S_AXI_ARREADY; 
     assign wr_data_en = S_AXI_WVALID && S_AXI_WREADY; 
     assign rd_data_en = S_AXI_RVALID && S_AXI_RREADY; 
     assign wr_addr_en_lane1 = S_AXI_AWVALID_LANE1 && S_AXI_AWREADY_LANE1; 
     assign rd_addr_en_lane1 = S_AXI_ARVALID_LANE1 && S_AXI_ARREADY_LANE1; 
     assign wr_data_en_lane1 = S_AXI_WVALID_LANE1 && S_AXI_WREADY_LANE1; 
     assign rd_data_en_lane1 = S_AXI_RVALID_LANE1 && S_AXI_RREADY_LANE1; 
     assign wr_addr_en_lane2 = S_AXI_AWVALID_LANE2 && S_AXI_AWREADY_LANE2; 
     assign rd_addr_en_lane2 = S_AXI_ARVALID_LANE2 && S_AXI_ARREADY_LANE2; 
     assign wr_data_en_lane2 = S_AXI_WVALID_LANE2 && S_AXI_WREADY_LANE2; 
     assign rd_data_en_lane2 = S_AXI_RVALID_LANE2 && S_AXI_RREADY_LANE2; 
     assign wr_addr_en_lane3 = S_AXI_AWVALID_LANE3 && S_AXI_AWREADY_LANE3; 
     assign rd_addr_en_lane3 = S_AXI_ARVALID_LANE3 && S_AXI_ARREADY_LANE3; 
     assign wr_data_en_lane3 = S_AXI_WVALID_LANE3 && S_AXI_WREADY_LANE3; 
     assign rd_data_en_lane3 = S_AXI_RVALID_LANE3 && S_AXI_RREADY_LANE3; 
 
     assign DRPADDR_IN          =  (wr_addr_en) ? S_AXI_AWADDR[8:0]  
                                  : (rd_addr_en) ? S_AXI_ARADDR[8:0] : 
 (wr_addr_en_lane1) ? S_AXI_AWADDR[8:0]  
                                  : (rd_addr_en_lane1) ? S_AXI_ARADDR[8:0] : 
 (wr_addr_en_lane2) ? S_AXI_AWADDR[8:0]  
                                  : (rd_addr_en_lane2) ? S_AXI_ARADDR[8:0] : 
 (wr_addr_en_lane3) ? S_AXI_AWADDR[8:0]  
                                  : (rd_addr_en_lane3) ? S_AXI_ARADDR[8:0] : 
                                'h0; 
     assign DRPDI_IN            =  (wr_data_en) ? S_AXI_WDATA[15:0] :  
 (wr_data_en_lane1) ? S_AXI_WDATA[15:0] :  
 (wr_data_en_lane2) ? S_AXI_WDATA[15:0] :  
 (wr_data_en_lane3) ? S_AXI_WDATA[15:0] :  
                                'h0;
 
     assign S_AXI_RDATA[15:0]   =  (rd_data_en) ? DRPDO_OUT :  
 (rd_data_en_lane1) ? DRPDO_OUT_LANE1 :  
 (rd_data_en_lane2) ? DRPDO_OUT_LANE2 :  
 (rd_data_en_lane3) ? DRPDO_OUT_LANE3 :  
                                'h0;
 
     assign DRPEN_IN   = (wr_addr_en) ? 1'b1 : (rd_addr_en) ? 1'b1 : 1'b0; 
     assign DRPEN_IN_LANE1   = (wr_addr_en_lane1) ? 1'b1 : (rd_addr_en_lane1) ? 1'b1 : 1'b0; 
     assign DRPEN_IN_LANE2   = (wr_addr_en_lane2) ? 1'b1 : (rd_addr_en_lane2) ? 1'b1 : 1'b0; 
     assign DRPEN_IN_LANE3   = (wr_addr_en_lane3) ? 1'b1 : (rd_addr_en_lane3) ? 1'b1 : 1'b0; 
     assign DRPWE_IN   = (wr_data_en) ? 1'b1 : 1'b0;  
     assign DRPWE_IN_LANE1   = (wr_data_en_lane1) ? 1'b1 : 1'b0;  
     assign DRPWE_IN_LANE2   = (wr_data_en_lane2) ? 1'b1 : 1'b0;  
     assign DRPWE_IN_LANE3   = (wr_data_en_lane3) ? 1'b1 : 1'b0;  
 
     assign S_AXI_BVALID = DRPRDY_OUT; 
     assign S_AXI_BVALID_LANE1 = DRPRDY_OUT_LANE1; 
     assign S_AXI_BVALID_LANE2 = DRPRDY_OUT_LANE2; 
     assign S_AXI_BVALID_LANE3 = DRPRDY_OUT_LANE3; 
 
 endmodule
